//+------------------------------------------------------------------+
//|                                                        +2bc+.mq4 |
//|                                        Copyright  2008, masemus |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, masemus"
#property link      "masemus@yahoo.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_color3 Silver
#property indicator_color4 Gray
#property indicator_color5 Red

#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 2
#property indicator_width5 1

extern int TF=0;
extern int BearBulls=13;
extern int CCI_1=2;
extern int CCI_2=5;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double Bears0;
double Bulls0;
double CCI01;
double CCI02;
double CCIBuffer1[];
double CCIBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- indicators
  SetIndexStyle(0,DRAW_HISTOGRAM);
  SetIndexBuffer(0,ExtMapBuffer1);
  SetIndexStyle(1,DRAW_HISTOGRAM);
  SetIndexBuffer(1,ExtMapBuffer2);
  SetIndexStyle(2,DRAW_HISTOGRAM);
  SetIndexBuffer(2,ExtMapBuffer3);
  SetIndexStyle(3,DRAW_LINE);
  SetIndexBuffer(3,CCIBuffer1);
  SetIndexStyle(4,DRAW_LINE);
  SetIndexBuffer(4,CCIBuffer2);

  SetIndexLabel(0,NULL);
  SetIndexLabel(1,NULL);
  SetIndexLabel(2,NULL);
//+------------------------------------------------------------------+
   string MTF="";
   double cTF=Period();

               if (cTF==PERIOD_M1) { MTF="M1"; }
               if (cTF==PERIOD_M5) { MTF="M5"; }
               if (cTF==PERIOD_M15) { MTF="M15"; }
               if (cTF==PERIOD_M30) { MTF="M30"; }
               if (cTF==PERIOD_H1) { MTF="H1"; }
               if (cTF==PERIOD_H4) { MTF="H4"; }
               if (cTF==PERIOD_D1) { MTF="D1"; }
               if (cTF==PERIOD_W1) { MTF="W1"; }
               if (cTF==PERIOD_MN1) { MTF="MN1"; }

               else if (TF == 1) { MTF="M1"; }
               else if (TF == 5) { MTF="M5"; }
               else if (TF == 15) { MTF="M15"; }
               else if (TF == 30) { MTF="M30"; }
               else if (TF == 60) { MTF="H1"; }
               else if (TF == 240) { MTF="H4"; }
               else if (TF == 1440) { MTF="D1"; }
               else if (TF == 10080) { MTF="W1"; }
               else if (TF == 43200) { MTF="MN1"; }
//+------------------------------------------------------------------+
   IndicatorShortName("+2bc :: "+MTF+"");  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,Bshift,limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for( i=limit; i>=0; i--)
   {
   Bshift=iBarShift(Symbol(),TF,Time[i]); 
   CCIBuffer2[i]=iCCI(NULL,TF,CCI_2,PRICE_TYPICAL,Bshift);
   CCIBuffer1[i]=iCCI(NULL,TF,CCI_1,PRICE_TYPICAL,Bshift);

   ExtMapBuffer1[i]=0;
   ExtMapBuffer2[i]=0;
   ExtMapBuffer3[i]=-1;
 
   Bears0=iBearsPower(NULL,TF,BearBulls,PRICE_TYPICAL,Bshift);
   Bulls0=iBullsPower(NULL,TF,BearBulls,PRICE_TYPICAL,Bshift);
   CCI01=iCCI(NULL,TF,CCI_1,PRICE_TYPICAL,Bshift);
   CCI02=iCCI(NULL,TF,CCI_2,PRICE_TYPICAL,Bshift);

     if (CCI01<CCI02 && Bulls0>=0 && CCI01>=0 && CCI02>=0) {ExtMapBuffer1[i]=30;}
     else if (CCI01>CCI02 && Bears0<=0 && CCI01<=0 && CCI02<=0) {ExtMapBuffer2[i]=-30;}
          else {ExtMapBuffer3[i]=1;}

   }



//----
   return(0);
  }
//+------------------------------------------------------------------+

